package examples;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import jp.sf.beanbinder.BeanBinder;
import jp.sf.beanbinder.BeanBinderFactory;
import jp.sf.beanbinder.annotations.AnnotationParser;
import jp.sf.beanbinder.annotations.Basic;
import jp.sf.beanbinder.component.swing.DateBox;
import jp.sf.beanbinder.exception.ValidateException;
import model.Employee;

public class DateExample extends JFrame implements ActionListener {
    public BeanBinder binder = BeanBinderFactory.createSwingBinder();
    
    @Basic( objectKey="emp", prop="creation" )
    private DateBox comp;
    
    public DateExample() {
        this.setTitle("Dateオブジェクトのサンプル");
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setSize(640, 480);
        this.setLayout(null);
    
        //日付コンポーネントの配置
        this.comp = new DateBox();
        this.comp.setBounds(10, 10, 240, 20);
        this.add(this.comp);
        
        //サンプルオブジェクト
        Employee employee = new Employee();
        employee.setCreation( new Date("2007/4/1") );//入社日
        this.binder.setObject("emp", employee);
        
        //アノテーションからマッピング
        new AnnotationParser(this.binder, this).parse();
        
        //リスナーの追加
        comp.addActionListener(this);
        
        //画面の再描画
        this.binder.updateComponent(".*");
    }
    public void actionPerformed(ActionEvent e) {
        try {
            //オブジェクトの更新
            this.binder.updateObject("emp");
            
            //オブジェクトの取得
            Employee employee = (Employee)this.binder.getObject("emp");
            
            //更新後の結果を表示
            JOptionPane.showMessageDialog(this,
                    "日付:"+employee.getCreation().toLocaleString(),
                    "オブジェクトは更新されました",
                    JOptionPane.INFORMATION_MESSAGE );
        }catch(ValidateException ex) {
            ex.printStackTrace();
        }
    }
    public static void main(String[] args) {
        new DateExample().setVisible(true);
    }
}
